
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


#ifndef __ICA_API_H__
#define __ICA_API_H__

/***************************************************************************
***                                                                      ***
***       (C) COPYRIGHT IBM CORP  2000                                   ***
***                                                                      ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                         ***
***                                                                      ***
***       All Rights Reserved                                            ***
***                                                                      ***
***       U.S. Government Users Restricted Rights - Use,                 ***
***       duplication or disclosure restricted by GSA ADP                ***
***       Schedule Contract with IBM Corp.                               ***
***                                                                      ***
***                                                                      ***
***       ORIGINS: IBM Charlotte, Department VM9A                        ***
***                                                                      ***
****************************************************************************
*                                                                          *
* Module Name:       ica_api.h                                             *
*                                                                          *
* Descriptive Name:  IBM Cryptographic Accelerator (ICA) API header file   *
*                                                                          *
* Status:            Release 1 Version 0                                   *
*                                                                          *
* Function:          Header file containing public library functions       *
*                                                                          *
*                                                                          *
* Module type:                                                             *
*      Platforms:    Windows NT, AIX, Linux                                *
*                                                                          *
*      Language:     C source                                              *
*                                                                          *
*      Compilers:    IBM VisualAge, GNU gcc                                *
*                                                                          *
* Restrictions:                                                            *
*                                                                          *
* Linkage:           Linked by customer program                            *
*                                                                          *
****************************************************************************
*                                                                          *
* Change History:                                                          *
*                                                                          *
* Date        Init  Comment                                                *
* ----------  ----  ----------------------------------------------------   *
* Oct 12, 00  JA    Create file                                            *
*                                                                          *
*                                                                          *
****************************************************************************/

/**
 ** abstract data types for API
 **/

#define ICA_ADAPTER_HANDLE int

/**
 ** RSA key generation options - public exponent types
 **/

#define RSA_PUBLIC_RANDOM 0
#define RSA_PUBLIC_3      1
#define RSA_PUBLIC_65537  2
#define RSA_PUBLIC_FIXED  3

/**
 ** DES options
 **/

/* FIXME MAC & SHA? */
#define MODE_DES_ECB      1
#define MODE_DES_CBC      2
/*#define MODE_MAC          0xC0000000*/
/*#define MODE_SHA1         0x40000000*/


/*------------------------------------------------*
 | SHA defines and typedefs                       |
 *------------------------------------------------*/
#define SHA_MSG_PART_ONLY       0
#define SHA_MSG_PART_FIRST      1
#define SHA_MSG_PART_MIDDLE     2
#define SHA_MSG_PART_FINAL      3
#define LENGTH_SHA_HASH         20


#if defined(linux) || defined (_AIX)
#define ICA_CALL 
#endif

#if defined(_WIN32)
 typedef struct {
         unsigned long upper;
         unsigned long lower;
 } DBL_ULONG;
#endif

 typedef struct _SHA_CONTEXT{
#if defined (_WIN32)
        DBL_ULONG          runningLength;
#elif defined (_AIX)
   #if   defined (__64BIT__)
        unsigned long      runningLength;
   #else
        unsigned long long runningLength;
   #endif
#elif defined (linux)
   #ifdef __s390__
        unsigned long long runningLength;
   #else
        unsigned long runningLength;
   #endif
#endif
        unsigned char      shaHash[LENGTH_SHA_HASH];
 } SHA_CONTEXT;
#define LENGTH_SHA_CONTEXT  sizeof(SHA_CONTEXT)

/*------------------------------------------------*
 | RSA defines and typedefs                       |
 *------------------------------------------------*/
 /*
 * All data elements of the RSA key are in big-endian format
 * Modulus-Exponent form of key
 *
 */
 #define MAX_EXP_SIZE 256
 #define MAX_MODULUS_SIZE 256
 #define MAX_MODEXP_SIZE  (MAX_EXP_SIZE + MAX_MODULUS_SIZE)

 #define MAX_OPERAND_SIZE  MAX_EXP_SIZE
 /**
 *
 *    _             ___________  <-base address + MAX_EXP_SIZE
 *    |
 *    |
 *    |
 *    |
 * MAX_EXPO_SIZE
 *    |              Modulus
 *    |             ----------  <-base address + sizeof(exponent)
 *    |
 *    |              Exponent
 *    _             ___________ <-base address of key
 *
 *   The Exponent and Modulus lengths are multiples of 32 bytes.
 *
 */

 typedef unsigned char ICA_KEY_RSA_MODEXPO_REC[MAX_MODEXP_SIZE];
 /*
 * All data elements of the RSA key are in big-endian format
 * Chinese Remainder Thereom(CRT) form of key
 * Used only for Decrypt, the encrypt form is typically Modulus-Exponent
 *
 */
 #define MAX_BP_SIZE 136
 #define MAX_BQ_SIZE 128
 #define MAX_NP_SIZE 136
 #define MAX_NQ_SIZE 128
 #define MAX_QINV_SIZE 136
 #define MAX_RSACRT_SIZE (MAX_BP_SIZE+MAX_BQ_SIZE+MAX_NP_SIZE+MAX_NQ_SIZE+MAX_QINV_SIZE)


#define RSA_GEN_OPERAND_MAX   256 /* bytes */
 /**
 *
 *    _             ___________  <-base address + MAX_RSACRT_SIZE
 *    |
 *    |              QINV(U)
 *    |             ----------  <-base address + sizeof(Bp)+sizeof(Bq)+sizeof(Np)+sizeof(Nq)
 *    |              Nq
 *    |             ----------  <-base address + sizeof(Bp)+sizeof(Bq)+sizeof(Np)
 *    |              Np
 *    |             ----------  <-base address + sizeof(Bp)+sizeof(Bq)
 * MAX_RSACRT_SIZE
 *    |              Bq
 *    |             ----------  <-base address + sizeofBp)
 *    |              Bp
 *    _             ___________ <-base address of key
 *
 *
 */

typedef unsigned char ICA_KEY_RSA_CRT_REC[MAX_RSACRT_SIZE];
/*------------------------------------------------*
 | RSA key token types                            |
 *------------------------------------------------*/

#define  RSA_PRIVATE_CHINESE_REMAINDER      1
#define  RSA_PRIVATE_MODULUS_EXPONENT       2
#define  RSA_PUBLIC_MODULUS_EXPONENT        3

#define  RSA_X931_PRIVATE_CHINESE_REMAINDER 4
#define  RSA_X931_PRIVATE_MODULUS_EXPONENT  5

#define  RSA_PKCS_PRIVATE_CHINESE_REMAINDER 6
#define  RSA_PKCS_X931_PRIVATE_CHINESE_REMAINDER 7

#define KEYTYPE_MODEXPO         1
#define KEYTYPE_PKCSCRT         2

/*------------------------------------------------*
 | RSA exponent types                             |
 *------------------------------------------------*/

#define  RSA_EXPONENT_RANDOM      1
#define  RSA_EXPONENT_3           2
#define  RSA_EXPONENT_65537       3
#define  RSA_EXPONENT_2           4
#define  RSA_EXPONENT_FIXED       5

/*------------------------------------------------*
 | RSA Key Token format                           |
 *------------------------------------------------*/

/*
 * NOTE:  All the fields in the ICA_KEY_RSA_MODEXPO structure
 *        (lengths, offsets, exponents, modulus, etc.) are
 *        stored in big-endian format
 */

typedef struct _ICA_KEY_RSA_MODEXPO
{   unsigned int  keyType;             /* RSA key type.               */
    unsigned int  keyLength;           /* Total length of the token.  */
    unsigned int  modulusBitLength;    /* Modulus n bit length.       */
                                       /* -- Start of the data length.*/
    unsigned int  nLength;             /* Modulus n = p * q           */
    unsigned int  expLength;           /* exponent (public or private)*/
                                       /*   e = 1/d * mod(p-1)(q-1)   */
                                       /* -- Start of the data offsets*/
    unsigned int  nOffset;             /* Modulus n .                 */
    unsigned int  expOffset;           /* exponent (public or private)*/
    unsigned char reserved[112];       /* reserved area               */
                                       /* -- Start of the variable -- */
                                       /* -- length token data.    -- */
    ICA_KEY_RSA_MODEXPO_REC keyRecord;
} ICA_KEY_RSA_MODEXPO;
#define SZ_HEADER_MODEXPO (sizeof(ICA_KEY_RSA_MODEXPO) - sizeof(ICA_KEY_RSA_MODEXPO_REC))

/*
 * NOTE:  All the fields in the ICA_KEY_RSA_CRT structure
 *        (lengths, offsets, exponents, modulus, etc.) are
 *        stored in big-endian format
 */

typedef struct _ICA_KEY_RSA_CRT
{   unsigned int  keyType;             /* RSA key type.               */
    unsigned int  keyLength;           /* Total length of the token.  */
    unsigned int  modulusBitLength;    /* Modulus n bit length.       */
                                       /* -- Start of the data length.*/
#if _AIX
    unsigned int  nLength;             /* Modulus n = p * q           */
#endif
    unsigned int  pLength;             /* Prime number p .            */
    unsigned int  qLength;             /* Prime number q .            */
    unsigned int  dpLength;            /* dp = d * mod(p-1) .         */
    unsigned int  dqLength;            /* dq = d * mod(q-1) .         */
    unsigned int  qInvLength;          /* PKCS: qInv = Ap/q           */
                                       /* -- Start of the data offsets*/
#if _AIX
    unsigned int  nOffset;             /* Modulus n .                 */
#endif
    unsigned int  pOffset;             /* Prime number p .            */
    unsigned int  qOffset;             /* Prime number q .            */
    unsigned int  dpOffset;            /* dp .                        */
    unsigned int  dqOffset;            /* dq .                        */
    unsigned int  qInvOffset;          /* qInv for PKCS               */
#if _AIX
    unsigned char reserved[80];        /* reserved area               */
#else
    unsigned char reserved[88];        /* reserved area               */
#endif
                                       /* -- Start of the variable -- */
                                       /* -- length token data.    -- */
    ICA_KEY_RSA_CRT_REC keyRecord;
} ICA_KEY_RSA_CRT;
#define SZ_HEADER_CRT (sizeof(ICA_KEY_RSA_CRT) - sizeof(ICA_KEY_RSA_CRT_REC))

/*------------------------------------------------*
 | DES defines and typedefs                       |
 *------------------------------------------------*/
 typedef unsigned char ICA_DES_VECTOR[8];

 typedef unsigned char ICA_KEY_DES_SINGLE[8];

 typedef struct _ICA_KEY_DES_TRIPLE{
        ICA_KEY_DES_SINGLE key1;
        ICA_KEY_DES_SINGLE key2;
        ICA_KEY_DES_SINGLE key3;
 } ICA_KEY_DES_TRIPLE;

/*------------------------------------------------*
 | Adapter ID block format                        |
 *------------------------------------------------*/
/*
 *      VendorID: 0x1014
 *      DeviceID: 0x01E6
 *      RevisionID: Not defined, assume 0
 *
 */

typedef struct
{  unsigned short  VendorID;
   unsigned short  DeviceID;
   unsigned char   RevisionID;
   unsigned char   ReservedByte;
} icaAdapterID_t;
typedef icaAdapterID_t ICA_ADAPTER_ID;

/*------------------------------------------------*
 | Adapter Vital Product Data (VPD)               |
 *------------------------------------------------*/
/*
* See the Driver High Level Design for VPD detail
*
*/

#define szVPD  512 /* VPD data is 512 bytes */
typedef unsigned char ICA_ADAPTER_VPD[szVPD];


/**
 ** prototypes for external API's
 **/

/*---------------------------------------------------------------------*
 |                                                                     |
 | icaGetAdapterMask                                                   |
 |                                                                     |
 | Purpose: Query the system for the adapters installed on the system. |
 |                                                                     |
 | Parameters:                                                         |
 |    pAdapterMask  - pointer where the results are returned and       |
 |                    will contain the "bit mask" of the adapters      |
 |                    in the "Available" state on the system. Adapter  |
 |                    zero is the low order bit. For example, if a     |
 |                    value of 0x0005 is returned in pAdapterMask,     |
 |                    then adapters 0 and 2 are in the "Available"     |
 |                    state.                                           |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaGetAdapterMask( unsigned int *pAdapterMask );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaGetAdapterID                                                     |
 |                                                                     |
 | Purpose: Retrieve the ID information from a specific adapter for    |
 |          later use by the application.                              |
 |                                                                     |
 | Parameters:                                                         |
 |    adapterId - the adapter number from which the ID is to be        |
 |                retrieved and must be in the range of 0 to 3         |
 |                inclusive.                                           |
 |                                                                     |
 |    pAdapterInfo - pointer where the adapter ID is to be placed.     |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaGetAdapterID( unsigned int    adapterId,
		 ICA_ADAPTER_ID *pAdapterInfo );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaGetVPD                                                           |
 |                                                                     |
 | Purpose: Retrieve the Vital Product Data (VPD) information from     |
 |          a specific adapter.                                        |
 |                                                                     |
 | Parameters:                                                         |
 |    adapterId - the adapter number from which the VPD is to be       |
 |                retrieved and must be in the range of 0 to 3         |
 |                inclusive.                                           |
 |                                                                     |
 |    pAdapterInfo - pointer where the adapter VPD is to be placed.    |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaGetVPD( unsigned int     adapterId,
	   ICA_ADAPTER_VPD *pAdapterInfo );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaOpenAdapter                                                      |
 |                                                                     |
 | Purpose: Open the adapter for subsequent use by the application.    |
 |                                                                     |
 | Parameters:                                                         |
 |    adapterId - the adapter number for the device to be opened       |
 |                and must be in the range of 0 to 3 inclusive.        |
 |                                                                     |
 |    pAdapterHandle - pointer to where the handle is to be placed.    |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaOpenAdapter( unsigned int        adapterId,
	        ICA_ADAPTER_HANDLE *pAdapterHandle );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaCloseAdapter                                                     |
 |                                                                     |
 | Purpose: Closes a device handle.                                    |
 |                                                                     |
 | Parameters:                                                         |
 |    pAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaCloseAdapter( ICA_ADAPTER_HANDLE adapterHandle );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaModExpo                                                       |
 |                                                                     |
 | Purpose: Perform a RSA encryption/decryption operation using a      |
 |          key in modulus/exponent form.                              |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    inputDataLength - the byte length of the input data and must     |
 |                      be 1 to 256 inclusive.                         |
 |                                                                     |
 |    pInputData - pointer to input data to be encrypted/decrypted and |
 |                      is in big endian format.                       |
 |                                                                     |
 |    pKeyModExpo - pointer to the key to be used, in modulus/exponent |
 |                  format.                                            |
 |                                                                     |
 |    pOutputDataLength - on input it contains the byte length of      |
 |                        pOutputData and must be as large as the      |
 |                        modulus byte length. On output it contains   |
 |                        the actual byte length of pOutputData.       |
 |                                                                     |
 |    pOutputData - pointer to where the output results are to be      |
 |                  placed.                                            |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRsaModExpo( ICA_ADAPTER_HANDLE    hAdapterHandle,
	       unsigned int          inputDataLength,
	       unsigned char        *pInputData,
	       ICA_KEY_RSA_MODEXPO  *pKeyModExpo,
	       unsigned int         *pOutputDataLength,
	       unsigned char        *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaCrt                                                           |
 |                                                                     |
 | Purpose: Perform a RSA decryption on input data using a key in      |
 |          Chinese Remainder Thereom (CRT) format.                    |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    inputDataLength - the byte length of the input data and must     |
 |                      be 1 to 256 inclusive.                         |
 |                                                                     |
 |    pInputData - pointer to input data to be decrypted and           |
 |                      is in big endian format.                       |
 |                                                                     |
 |    pKeyModCrt - pointer to the key to be used, in CRT format.       |
 |                                                                     |
 |    pOutputDataLength - on input it contains the byte length of      |
 |                        pOutputData and must be as large as the      |
 |                        modulus byte length. On output it contains   |
 |                        the actual byte length of pOutputData.       |
 |                                                                     |
 |    pOutputData - pointer to where the output results are to be      |
 |                  placed.                                            |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRsaCrt( ICA_ADAPTER_HANDLE     hAdapterHandle,
	   unsigned int           inputDataLength,
	   unsigned char         *pInputData,
	   ICA_KEY_RSA_CRT       *pKeyCrt,
	   unsigned int          *pOutputDataLength,
	   unsigned char         *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaKeyGenerateModExpo                                            |
 |                                                                     |
 | Purpose: Generate RSA keys in modulus/exponent format.              |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    modulusBitLength - specifies the bit length of the modulus.      |
 |                                                                     |
 |    exponentTypePublic - specifies the type of the public exponent   |
 |                         and should be one of the following:         |
 |                                                                     |
 |                         0 - full random public exponent             |
 |                         1 - fixed value 3 public exponent           |
 |                         2 - fixed value 65537 public exponent       |
 |                                                                     |
 |    pKeyPublicLength - on input is the length of the pKeyPublic      |
 |                       buffer. On output contains the actual length  |
 |                       of the generated public key.                  |
 |                                                                     |
 |    pKeyPublic - pointer to where the generated public key is to     |
 |                 be placed.                                          |
 |                                                                     |
 |    pKeyPrivateLength - on input it contains the byte length of      |
 |                        pKeyPrivate. On output it contains the       |
 |                        actual length of the generated private key.  |
 |                                                                     |
 |    pKeyPrivate - pointer to where the generated private key is to   |
 |                  be placed.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRsaKeyGenerateModExpo( ICA_ADAPTER_HANDLE   hAdapterHandle,
			  unsigned int         modulusBitLength,
			  unsigned int         exponentTypePublic,
			  unsigned int        *pKeyPublicLength,
			  ICA_KEY_RSA_MODEXPO *pKeyPublic,
			  unsigned int        *pKeyPrivateLength,
			  ICA_KEY_RSA_MODEXPO *pKeyPrivate );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaKeyGenerateCrt                                                |
 |                                                                     |
 | Purpose: Generate RSA keys in Chinese Remainder Thereom (CRT)       |
 |          format.                                                    |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    modulusBitLength - specifies the bit length of the modulus.      |
 |                                                                     |
 |    exponentTypePublic - specifies the type of the public exponent   |
 |                         and should be one of the following:         |
 |                                                                     |
 |                         0 - full random public exponent             |
 |                         1 - fixed value 3 public exponent           |
 |                         2 - fixed value 65537 public exponent       |
 |                                                                     |
 |    pKeyPublicLength - on input is the length of the pKeyPublic      |
 |                       buffer. On output contains the actual length  |
 |                       of the generated public key.                  |
 |                                                                     |
 |    pKeyPublic - pointer to where the generated public key is to     |
 |                 be placed.                                          |
 |                                                                     |
 |    pKeyPrivateLength - on input it contains the byte length of      |
 |                        pKeyPrivate. On output it contains the       |
 |                        actual length of the generated private key.  |
 |                                                                     |
 |    pKeyPrivate - pointer to where the generated private key is to   |
 |                  be placed.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/
                                               
unsigned int
icaRsaKeyGenerateCrt( ICA_ADAPTER_HANDLE   hAdapterHandle,
		      unsigned int         modulusBitLength,
		      unsigned int         exponentTypePublic,
		      unsigned int        *pKeyPublicLength,
		      ICA_KEY_RSA_MODEXPO *pKeyPublic,
		      unsigned int        *pKeyPrivateLength,
		      ICA_KEY_RSA_CRT     *pKeyPrivate );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaKeyReGenerateModExpo                                          |
 |                                                                     |
 | Purpose: Deterministically regenerate RSA keys in modulus/exponent  |
 |          format from a fixed, given input.                          |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    modulusBitLength - specifies the bit length of the modulus.      |
 |                                                                     |
 |    exponentTypePublic - specifies the type of the public exponent   |
 |                         and should be one of the following:         |
 |                                                                     |
 |                         0 - full random public exponent             |
 |                         1 - fixed value 3 public exponent           |
 |                         2 - fixed value 65537 public exponent       |
 |                                                                     |
 |    regenDataLength - specifies the length of the regeneration data  |
 |                      and must not be zero.                          |
 |                                                                     |
 |    pRegenData - pointer to the data which will be SHA-1 hashed and  |
 |                 then be used to start the prime number generation.  |
 |                                                                     |
 |    pKeyPublicLength - on input is the length of the pKeyPublic      |
 |                       buffer. On output contains the actual length  |
 |                       of the generated public key.                  |
 |                                                                     |
 |    pKeyPublic - pointer to where the generated public key is to     |
 |                 be placed.                                          |
 |                                                                     |
 |    pKeyPrivateLength - on input it contains the byte length of      |
 |                        pKeyPrivate. On output it contains the       |
 |                        actual length of the generated private key.  |
 |                                                                     |
 |    pKeyPrivate - pointer to where the generated private key is to   |
 |                  be placed.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRsaKeyRegenerateModExpo( ICA_ADAPTER_HANDLE   hAdapterHandle,
			    unsigned int         modulusBitLength,
			    unsigned int         exponentTypePublic,
			    unsigned int         regenDataLength,
			    unsigned char       *pRegenData,
			    unsigned int        *pKeyPublicLength,
			    ICA_KEY_RSA_MODEXPO *pKeyPublic,
			    unsigned int        *pKeyPrivateLength,
			    ICA_KEY_RSA_MODEXPO *pKeyPrivate );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRsaKeyReGenerateCrt                                              |
 |                                                                     |
 | Purpose: Deterministically regenerate RSA keys in Chinese Remainder |
 |          Thereom (CRT) format.                                      |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    modulusBitLength - specifies the bit length of the modulus.      |
 |                                                                     |
 |    exponentTypePublic - specifies the type of the public exponent   |
 |                         and should be one of the following:         |
 |                                                                     |
 |                         0 - full random public exponent             |
 |                         1 - fixed value 3 public exponent           |
 |                         2 - fixed value 65537 public exponent       |
 |                                                                     |
 |    regenDataLength - specifies the length of the regeneration data  |
 |                      and must not be zero.                          |
 |                                                                     |
 |    pRegenData - pointer to the data which will be SHA-1 hashed and  |
 |                 then be used to start the prime number generation.  |
 |                                                                     |
 |    pKeyPublicLength - on input is the length of the pKeyPublic      |
 |                       buffer. On output contains the actual length  |
 |                       of the generated public key.                  |
 |                                                                     |
 |    pKeyPublic - pointer to where the generated public key is to     |
 |                 be placed.                                          |
 |                                                                     |
 |    pKeyPrivateLength - on input it contains the byte length of      |
 |                        pKeyPrivate. On output it contains the       |
 |                        actual length of the generated private key.  |
 |                                                                     |
 |    pKeyPrivate - pointer to where the generated private key is to   |
 |                  be placed.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRsaKeyRegenerateCrt( ICA_ADAPTER_HANDLE   hAdapterHandle,
			unsigned int         modulusBitLength,
			unsigned int         exponentTypePublic,
			unsigned int         regenDataLength,
			unsigned char       *pRegenData,
			unsigned int        *pKeyPublicLength,
			ICA_KEY_RSA_MODEXPO *pKeyPublic,
			unsigned int        *pKeyPrivateLength,
			ICA_KEY_RSA_CRT     *pKeyPrivate );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaDesEncrypt                                                       |
 |                                                                     |
 | Purpose: Encrypt data using a single length DES key.                |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    mode - specifies the operational mode and must be:               |
 |                                                                     |
 |           MODE_DES_ECB - use Electronic Code Book mode              |
 |           MODE_DES_CBC - use Cipher Block Chaining mode             |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data to be encrypted.     |
 |                                                                     |
 |    pIv - pointer to a valid 8 byte initialization vector.           |
 |                                                                     |
 |    pKeyDes - pointer to a single length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer and must be as large as   |
 |                        dataLength. On output it contains the        |
 |                        actual byte length of the data returned in   |
 |                        pOutputData.                                 |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  encrypted data.                                    |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaDesEncrypt( ICA_ADAPTER_HANDLE      hAdapterHandle,
	       unsigned int            mode,
	       unsigned int            dataLength,
	       unsigned char          *pInputData,
	       ICA_DES_VECTOR         *pIv,
	       ICA_KEY_DES_SINGLE     *pKeyDes,
	       unsigned int           *pOutputDataLength,
	       unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaDesDecrypt                                                       |
 |                                                                     |
 | Purpose: Decrypt data using a single length DES key.                |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    mode - specifies the operational mode and must be:               |
 |                                                                     |
 |           MODE_DES_ECB - use Electronic Code Book                   |
 |           MODE_DES_CBC - use Cipher Block Chaining mode             |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data to be decrypted.     |
 |                                                                     |
 |    pIv - pointer to a valid 8 byte initialization vector.           |
 |                                                                     |
 |    pKeyDes - pointer to a single length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer and must be as large as   |
 |                        dataLength. On output it contains the        |
 |                        actual byte length of the data returned in   |
 |                        pOutputData.                                 |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  decrypted data.                                    |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaDesDecrypt( ICA_ADAPTER_HANDLE      hAdapterHandle,
	       unsigned int            mode,
	       unsigned int            dataLength,
	       unsigned char          *pInputData,
	       ICA_DES_VECTOR         *pIv,
	       ICA_KEY_DES_SINGLE     *pKeyDes,
	       unsigned int           *pOutputDataLength,
	       unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaTDesEncrypt                                                      |
 |                                                                     |
 | Purpose: Encrypt data using a triple length DES key.                |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    mode - specifies the operational mode and must be:               |
 |                                                                     |
 |           MODE_DES_ECB - use Electronic Code Book                   |
 |           MODE_DES_CBC - use Cipher Block Chaining mode             |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data to be encrypted.     |
 |                                                                     |
 |    pIv - pointer to a valid 8 byte initialization vector.           |
 |                                                                     |
 |    pKeyDes - pointer to a triple length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer and must be as large as   |
 |                        dataLength. On output it contains the        |
 |                        actual byte length of the data returned in   |
 |                        pOutputData.                                 |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  encrypted.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaTDesEncrypt( ICA_ADAPTER_HANDLE      hAdapterHandle,
		unsigned int            mode,
		unsigned int            dataLength,
		unsigned char          *pInputData,
		ICA_DES_VECTOR         *pIv,
		ICA_KEY_DES_TRIPLE     *pKeyDes,
		unsigned int           *pOutputDataLength,
		unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaTDesDecrypt                                                      |
 |                                                                     |
 | Purpose: Decrypt data using a triple length DES key.                |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    mode - specifies the operational mode and must be:               |
 |                                                                     |
 |           MODE_DES_ECB - use Electronic Code Book                   |
 |           MODE_DES_CBC - use Cipher Block Chaining mode             |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data to be decrypted.     |
 |                                                                     |
 |    pIv - pointer to a valid 8 byte initialization vector.           |
 |                                                                     |
 |    pKeyDes - pointer to a triple length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer and must be as large as   |
 |                        dataLength. On output it contains the        |
 |                        actual byte length of the data returned in   |
 |                        pOutputData.                                 |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  decrypted.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaTDesDecrypt( ICA_ADAPTER_HANDLE      hAdapterHandle,
		unsigned int            mode,
		unsigned int            dataLength,
		unsigned char          *pInputData,
		ICA_DES_VECTOR         *pIv,
		ICA_KEY_DES_TRIPLE     *pKeyDes,
		unsigned int           *pOutputDataLength,
		unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaDesMac                                                           |
 |                                                                     |
 | Purpose: Perform a Message Authenication Code (MAC) on input data   |
 |          using a single length DES key.                             |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data.                     |
 |                                                                     |
 |    pIcv - pointer to the input ICV.                                 |
 |                                                                     |
 |    pKeyDes - pointer to a single length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer. On output it contains    |
 |                        the actual byte length of the MAC returned   |
 |                        in pOutputData.                              |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  MAC data.                                          |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaDesMac( ICA_ADAPTER_HANDLE      hAdapterHandle,
	   unsigned int            dataLength,
	   unsigned char          *pInputData,
	   ICA_DES_VECTOR         *pIcv,
	   ICA_KEY_DES_SINGLE     *pKeyDes,
	   unsigned int           *pOutputDataLength,
	   unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaTDesMac                                                          |
 |                                                                     |
 | Purpose: Perform a Message Authenication Code (MAC) on input data   |
 |          using a triple length DES key.                             |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    dataLength - specifies the byte length of the input data.        |
 |                 Must be a mutiple of the cipher block.              |
 |                                                                     |
 |    pInputData - pointer to the input data data.                     |
 |                                                                     |
 |    pIcv - pointer to the input ICV.                                 |
 |                                                                     |
 |    pKeyDes - pointer to a triple length DES key.                    |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer. On output it contains    |
 |                        the actual byte length of the MAC returned   |
 |                        in pOutputData.                              |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  MAC data.                                          |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaTDesMac( ICA_ADAPTER_HANDLE      hAdapterHandle,
	    unsigned int            inputDataLength,
	    unsigned char           *pInputData,
	    ICA_DES_VECTOR          *pIcv,
	    ICA_KEY_DES_TRIPLE      *pKeyDes,
	    unsigned int            *pOutputDataLength,
	    unsigned char           *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaSha1                                                             |
 |                                                                     |
 | Purpose: Perform secure hash on input data using the SHA-1          |
 |          algorithm.                                                 |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    shaMessagePart - the message chaining state. Must be one of the  |
 |                     following:                                      |
 |                                                                     |
 |                     SHA_MSG_PART_ONLY   - A single hash operation   |
 |                     SHA_MSG_PART_FIRST  - The first part            |
 |                     SHA_MSG_PART_MIDDLE - The middle part           |
 |                     SHA_MSG_PART_FINAL  - The last part             |
 |                                                                     |
 |    inputDataLength - the byte length of the input data to be        |
 |                      SHA-1 hashed and must be greater than zero.    |
 |                                                                     |
 |    pInputData - pointer to the input data data.                     |
 |                                                                     |
 |    shaContextLength - specifies the length of the SHA message       |
 |                       context structure and must contain a value    |
 |                       that is at least 28 decimal.                  |
 |                                                                     |
 |    pShaContext - pointer to the SHA-1 context structure used to     |
 |                  store the intermediate values when chaining is     |
 |                  used. The application must not modify the contents |
 |                  of this structure when chaining is used.           |
 |                                                                     |
 |    pOutputDataLength - on input specifies the length of the         |
 |                        pOutputData buffer and must be greater than  |
 |                        20. On output it contains the actual byte    |
 |                        length of the hash returned in pOutputData.  |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  hash data.                                         |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaSha1( ICA_ADAPTER_HANDLE      hAdapterHandle,
	 unsigned int            shaMessagePart,
	 unsigned int            inputDataLength,
	 unsigned char          *pInputData,
	 unsigned int            shaContextLength,
	 SHA_CONTEXT            *pShaContext,
	 unsigned int           *pOutputDataLength,
	 unsigned char          *pOutputData );


/*---------------------------------------------------------------------*
 |                                                                     |
 | icaRandomNumberGenerate                                             |
 |                                                                     |
 | Purpose: Generate a random number.                                  |
 |                                                                     |
 | Parameters:                                                         |
 |    hAdapterHandle - pointer to a previously opened device handle.   |
 |                                                                     |
 |    pOutputDataLength - specifies the byte length of the pOutputData |
 |                        buffer and the desired length of the random  |
 |                        number.                                      |
 |                                                                     |
 |    pOutputData - pointer to the buffer to contain the resulting     |
 |                  random number.                                     |
 |                                                                     |
 | Return code: Zero if successful                                     |
 |                                                                     |
 *---------------------------------------------------------------------*/

unsigned int
icaRandomNumberGenerate( ICA_ADAPTER_HANDLE  hAdapterHandle,
			 unsigned int        outputDataLength,
			 unsigned char      *pOutputData );

#endif   /* __ICA_API_H__ */
